#ifndef __api_inc__
#define __api_inc__

#ifndef DX2D_INC_INCLUDED
#include "..\\bin\\dx2d.inc" // for GUID
#endif

#typedef ITEMIDLIST pointer

struct CMINVOKECOMMANDINFO {
	int cbSize;
	int fMask;
	int hwnd;       // owner of the shortcut menu
	string* lpVerb; // menu-identifier in the low-order word
	string* lpParameters; // NULL for menu items
	string* lpDirectory;  // NULL for menu items
	int nShow;
	int dwHotKey;
	int hIcon;
}

extern _IID_IUnknown      as GUID;
extern _IID_IClassFactory as GUID;
extern _IID_IShellExtInit as GUID;
extern _IID_IContextMenu  as GUID;
extern _IID_IContextMenu2 as GUID;
extern _IID_IContextMenu3 as GUID;
extern _hinstance as int;

CONST E_NOINTERFACE = 0x80004002;
CONST SM_CXMENUCHECK = 71;
CONST SM_CYMENUCHECK = 72;
CONST CLASS_E_CLASSNOTAVAILABLE = 0x80040111;
CONST E_POINTER = 0x80004003;
CONST HKEY_CLASSES_ROOT = 0x80000000;
CONST HKEY_LOCAL_MACHINE = 0x80000002;
CONST SELFREG_E_CLASS = (0x80040200+1);
CONST REG_SZ = 1;
CONST CLASS_E_NOAGGREGATION = 0x80040110;
CONST MF_BYPOSITION = 0x400;
CONST MF_SEPARATOR = 0x800;
CONST COLOR_WINDOW = 5;
CONST DI_NORMAL = 0x0003;
CONST SW_HIDE = 0;
CONST MAX_PATH = 260;
CONST CF_HDROP = 15;
CONST DVASPECT_CONTENT = 1;
CONST TYMED_HGLOBAL = 1;
CONST INVALID_FILE_ATTRIBUTES = -1;
CONST FILE_ATTRIBUTE_DIRECTORY = 0x00000010;
CONST FO_DELETE = 3;
CONST FOF_ALLOWUNDO = 0x40;
CONST FOF_FILESONLY = 0x80;
CONST SHCNE_ASSOCCHANGED = 0x8000000;
CONST SHCNF_IDLIST = 0;
CONST GCS_HELPTEXTW = 5;
CONST GCS_UNICODE = 4;

declare import, InsertMenuA(int hMenu,int pos,int uFlags,int id,string *txt),int;
declare import, IsBadReadPtr(void *adr,int size),int;
declare import, IsBadWritePtr(void *adr,int size),int;
declare import, IsEqualGUID(GUID *a,GUID *b),int;

declare cdecl import, strncpy(string *dest,string *src,int max),int;
declare cdecl import, wcsncpy(wstring *dest,wstring *src,int max),int;
declare import, GetModuleFileNameA(int inst,string *buf,int size),int;
declare import, SHSetValueA(int hkey,string *SubKey,string *value,int type,string *data,int cbData),int;
declare import, SHDeleteKeyA(int hkey,string *pszSubKey),int;
declare import, SHDeleteValueA(int hkey,string *pszSubKey,string *value),int;
declare import, DragQueryFileA(int hDrop,int iFile,string *lpszFile,int cch),int;
declare import, ReleaseStgMedium(STGMEDIUM *m),int;
declare import, GetFileAttributesA(string *lpFileName),int;
declare import, SHFileOperation(SHFILEOPSTRUCT *op),int;
declare import, GetForegroundWindow(),int;
declare import, SHChangeNotify(int type,int flags,int param1,int param2);
declare import, RegCreateKeyA(int hkey,string* subkey,int* result),int;
declare import, RegCloseKey(int hkey),int;
declare import, SHGetPathFromIDListA(ITEMIDLIST* folder,string *path);

struct SHFILEOPSTRUCT
{
    int hwnd;
    word wFunc;
    string* pFrom;
    string* pTo;
    int fFlags;
    int fAnyOperationsAborted;
    void* hNameMappings;
    string* lpszProgressTitle;
}
struct STGMEDIUM
{
	int tymed;
	union
	{
		int hMetaFilePict;
		int hHEnhMetaFile;
		int *hGdiHandle;
		int hGlobal;
		wstring *lpszFileName;
		pointer pstm;//IStream
		pointer pstg;//IStorage
	}
	pointer pUnkForRelease;//IUnknown
}
struct FORMATETC
{
    int cfFormat;
    pointer ptd;
    int dwAspect;
    int lindex;
    int tymed;
}

interface IUnknown
{
	declare virtual QueryInterface(GUID *riid,void *ppvObject),int;
	declare virtual AddRef(),int;
	declare virtual Release(),int;
}

interface IDataObject : IUnknown
{
	declare virtual GetData(FORMATETC *pformatetcIn,/*out*/STGMEDIUM *pmedium),int;
	declare virtual GetDataHere(FORMATETC *pformatetc,/*out*/STGMEDIUM *pmedium),int;
	declare virtual QueryGetData(FORMATETC *pformatetc),HRESULT;
	declare virtual GetCanonicalFormatEtc(FORMATETC *pformatectIn,/*out*/FORMATETC *pformatetcOut),int;
	declare virtual SetData(FORMATETC *pformatetc,STGMEDIUM *pmedium,BOOL fRelease),int;
	declare virtual EnumFormatEtc(DWORD dwDirection,/*out*/IEnumFORMATETC *ppenumFormatEtc),int;
	declare virtual DAdvise(FORMATETC *pformatetc,DWORD advf,IAdviseSink *pAdvSink,/*out*/DWORD *pdwConnection),int;
	declare virtual DUnadvise(DWORD dwConnection),int;
	declare virtual EnumDAdvise(/*out*/IEnumSTATDATA *ppenumAdvise),int;
}

#endif
